# REPLference.jl Tasks

To contribute to the `REPLference.jl` package, you can solve tasks listed in the
[`# Todo`](https://github.com/udohjeremiah/REPLference.jl/blob/master/TODO.md#todo)
section of this file. These tasks are specific to the upcoming release. Here are the steps
to follow:

1. If you find an unassigned task in the
   [`# Todo`](https://github.com/udohjeremiah/REPLference.jl/blob/master/TODO.md#todo)
   section, add your username to the task name in the
   [`# In Progress...`](https://github.com/udohjeremiah/REPLference.jl/blob/master/TODO.md#in-progress)
   section. Also, include a link to the branch or repository you're working on and remove
   the task from the [`# Todo`](https://github.com/udohjeremiah/REPLference.jl/blob/master/TODO.md#todo)
   section. This indicates that you're working on it. For example:
   `Tasktitle [branch-name](https://github.com/<repo>) @john`.

2. If someone else is already working on a task that you want to help with, collaborate with
   them by opening a pull request in the branch or repository where the change is being
   made. Request to be added to the pull request. If accepted, the initial contributor who
   started working on the task should update the
   [`# In Progress...`](https://github.com/udohjeremiah/REPLference.jl/blob/master/TODO.md#in-progress)
   section to add your name to the list of usernames. This prevents duplication of effort
   and ensures efficient and effective development. For example:
   `Tasktitle [branch-name](https://github.com/<repo>) @john, @mary`.

3. When you finish a task, open a pull request with the changes. If the package maintainers
   approve and merge the pull request, open another pull request to remove the task from the
   [`# In Progress...`](https://github.com/udohjeremiah/REPLference.jl/blob/master/TODO.md#in-progress)
   and add it to the [`Done ✓`](https://github.com/udohjeremiah/REPLference.jl/blob/master/TODO.md#done-)
   section. In the comment section of the pull request, state the PR number for the merged
   pull request (generated by the hosting service). For example:
   `Remove Tasktitle from In Progress... and add to Done section: #1234`.

4. If a task in the [`# Todo`](https://github.com/udohjeremiah/REPLference.jl/blob/master/TODO.md#todo)
   section is not completed for the upcoming release, it will be carried over to the next
   release by default. However, the package maintainers may decide to remove it from the
   list. Before starting fresh for the next release, ensure that the
   [`Done ✓`](https://github.com/udohjeremiah/REPLference.jl/blob/master/TODO.md#done-)
   section is cleared.

To see what's happening in a section, click on the arrow symbol (▶).

## Todo

<details><summary></summary>

- [ ] Complete docstring for the `regexes` method in `src/_20_regex.jl`.
    - [ ] Provide a section discussing these topics:
        - [ ] Script Run
        - [ ] Callouts
        - [ ] Backtracking Control

- [ ] Complete the docstring for the `files` method in `src/_18_file.jl`.
    - [ ] Provide a section discussing these topics:
        - [ ] Changing the access permissions and attributes of a file.

- [ ] Create the `src` directory:
    - [ ] Create a `_24_error.jl` file that contains a manual about error handling in Julia
          and the methods that can be called on the topic.
    - [ ] Create a `_25_pointer.jl` file that contains a manual about pointers in Julia and
          the methods that can be called on them.
    - [ ] Create a `_26_system.jl` file that contains a manual about systems in Julia and
          the methods that can be called on the topic.
    - [ ] Create a `_27_thread.jl` file that contains a manual about threads in Julia and
          the methods that can be called on the topic.
</details>

## In Progress...

<details><summary></summary>
</details>

## Done ✓

<details><summary></summary>

- [x] Format the code to use `BlueStyle` via `JuliaFormatter.jl`:
      [`#57`](https://github.com/udohjeremiah/REPLference.jl/pull/57)
      [@udohjeremiah](https://github.com/udohjeremiah)
- [x] Create the `.JuliaFormatter.jl` file and use `BlueStyle`:
      [`#60`](https://github.com/udohjeremiah/REPLference.jl/pull/60)
      [@udohjeremiah](https://github.com/udohjeremiah)
- [x] Create the `_23_metaprogramming.jl` file:
      [`#64`](https://github.com/udohjeremiah/REPLference.jl/pull/64)
</details>
